#define STRICT

#include "resource.h"
#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>

#define MAX_CAR   27
#define NB_GEN    250

static HWND       mainWnd;         /* Main Window Handle          */
static HINSTANCE  hInst;           /* Main Window Instance        */

static unsigned int *cTable;       /* Global Markov table         */
static unsigned int *tab;          /* Local markov table browsing */
static unsigned long totalCar = 0; /* Number of car treated       */
static unsigned long idx = 0;      /* Local index in the table    */

static char szAppName[9];         /* Application name            */
static char szTitle[9];           /* Window title                */
static char szNoHelp[33];
static char szFirstDrag[24];
static char szHelpFile[24];

char int2Char(char car)
{
   char result = car;

   if (result < 26)
      result += (char) 'a';
   else result = ' ';

   return result;
}

char char2Int(char car)
{
   char result;

   if (car >= 'a' && car <= 'z')
      result = (char) (car - 'a');
   else if (car >= 'A' && car <= 'Z')
      result = (char) (car - 'A');
   else if(car == '\n' || car == '\t' || car == '\r' || car == ' ')
      result = MAX_CAR - 1;
   else switch (car)
   {
      case '': case '': case '': case '': case '': case '':
      case '': case '': case '': case '': case '': case '':
         result = 'a' - 'a';
         break;
      case '': case '': case '': case '':
      case '': case '': case '': case '':
         result = 'e' - 'a';
         break;
      case '': case '': case '': case '':
      case '': case '': case '': case '':
         result = 'i' - 'a';
         break;
      case '': case '': case '': case '': case '':
      case '': case '': case '': case '': case '':
         result = 'o' - 'a';
         break;
      case '': case '': case '': case '':
      case '': case '': case '': case '':
         result = 'u' - 'a';
         break;
      case '': case '': case '':
         result = 'y' - 'a';
         break;
      case '': case '':
         result = 'c' - 'a';
         break;
      case '': case '':
         result = 'n' - 'a';
         break;
      default :
         result = -1;
         break;
   }

   return result;
}

unsigned int *getTablePos(unsigned char car1,unsigned char car2,unsigned char car3,unsigned char car4)
{
   idx = 0;

   idx += char2Int(car1);
   idx *= MAX_CAR;
   idx += char2Int(car2);
   idx *= MAX_CAR;
   idx += char2Int(car3);
   idx *= MAX_CAR;
   idx += char2Int(car4);

   return &cTable[idx];
}

char randChar(void)
{
   return int2Char((char) (rand() % MAX_CAR));
}

void initString(char *sInit)
{
   unsigned long curr = 0;
   char i,j,k,l;

   tab = cTable;
   idx = (rand() + (rand() << 16)) % totalCar;

   for (i=0;i<MAX_CAR && curr <= idx;i++)
   for (j=0;j<MAX_CAR && curr <= idx;j++)
   for (k=0;k<MAX_CAR && curr <= idx;k++)
   for (l=0;l<MAX_CAR && curr <= idx;l++)
   {
      curr += tab[0];
      tab  += 1;
   }
   i--;j--;k--;l--;

   sInit[0] = int2Char(i);
   sInit[1] = int2Char(j);
   sInit[2] = int2Char(k);
   sInit[3] = int2Char(l);
}

char autoChar3(char car1,char car2,char car3)
{
   unsigned char i;
   char result;
   unsigned int total = 0,current = 0,generate = 0;
   
   tab = getTablePos(car1,car2,car3,'a');

   total = 0;
   for (i=0;i<MAX_CAR;i++)
   {
      total += tab[i];
   }

   if (total)
   {
      generate = (unsigned int) (rand() % total);
      i = 0;
      current = 0;
      while (tab[i] + current <= generate)
      {
         current += tab[i++];
      }
      result = i;
   }
   else result = (char) (rand() % MAX_CAR);

   return int2Char(result);
}

#pragma argsused
BOOL CALLBACK AppDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
   unsigned char j;
   unsigned int i;
   BOOL result;
   HDROP hDrop;
   HFILE *textfile;
   HWND tmpWnd;
   char szText[300];
   DWORD size,index;
   char char0,char1,char2,char3;

   switch(uMsg)
   {
      case WM_INITDIALOG :
         mainWnd = hDlg;
         SetClassLong(hDlg,GCL_HICON,(LONG)LoadIcon(hInst, MAKEINTRESOURCE(ICON_APP)));
         cTable = (unsigned int *)malloc(MAX_CAR*MAX_CAR*MAX_CAR*MAX_CAR*sizeof(unsigned int));
         /* Init the whole table */
         for (char0 = 0;char0 < MAX_CAR; char0++)
         for (char1 = 0;char1 < MAX_CAR; char1++)
         for (char2 = 0;char2 < MAX_CAR; char2++)
         for (char3 = 0;char3 < MAX_CAR; char3++)
         {
            tab = getTablePos(int2Char(char0),int2Char(char1),int2Char(char2),int2Char(char3));
            *tab = 0;
         }
         srand((WORD)GetTickCount());
         result = TRUE;
         break;
      case WM_DROPFILES:
         hDrop = (HDROP) wParam;
         i = (unsigned char) DragQueryFile(hDrop,-1,NULL,NULL);
         for (j = 0; j < i; j++)
         {
            DragQueryFile(hDrop,0,szText,sizeof(szText));
            textfile = CreateFile(szText,
                                 GENERIC_READ,
                                 FILE_SHARE_READ,
                                 NULL,
                                 OPEN_EXISTING,
                                 FILE_ATTRIBUTE_NORMAL,
                                 NULL);
            while(ReadFile(textfile,szText,1,&size,NULL) && size && char2Int(char0 = szText[0]) == -1);
            while(ReadFile(textfile,szText,1,&size,NULL) && size && char2Int(char1 = szText[0]) == -1);
            while(ReadFile(textfile,szText,1,&size,NULL) && size && char2Int(char2 = szText[0]) == -1);
            while(ReadFile(textfile,szText,sizeof(szText),&size,(LPOVERLAPPED)NULL) && size)
            {
               /* Fill the table */
               index = 0;
               while (char2Int(char3 = szText[index++]) == -1)
                  index++;
               while (index < size)
               {
                  tab = getTablePos(char0,char1,char2,char3);
                  *tab += 1;
                  char0 = char1;
                  char1 = char2;
                  char2 = char3;
                  while (char2Int(char3 = szText[index++]) == -1);
               }
               totalCar += size;
            }
            CloseHandle(textfile);
         }
         DragFinish(hDrop);
         result = FALSE;
         break;
      case WM_COMMAND:
         switch(GET_WM_COMMAND_ID(wParam,lParam))
         {
            case IDOK:
               /* Init */
               if (totalCar)
               {
                  initString(szText);
                  for (i = 4; i< NB_GEN + 4;i++)
                     szText[i] = autoChar3(szText[i-3],szText[i-2],szText[i-1]);
                  szText[i] = '\0';
                  tmpWnd = GetDlgItem(mainWnd,IDC_TEXTE);
                  SetWindowText(tmpWnd,szText);
               }
               else
               {
                  MessageBox(mainWnd,szFirstDrag,szAppName,MB_ICONINFORMATION|MB_OK);
               }
               break;
            case IDCANCEL:
               SendMessage(mainWnd,WM_CLOSE,NULL,NULL);
               break;
            case IDHELP:
            	if ((textfile = CreateFile(szHelpFile,
               									NULL,
                                          FILE_SHARE_READ,
                                          NULL,
                                          OPEN_EXISTING,
                                          FILE_ATTRIBUTE_NORMAL,
                                          NULL)) != NULL)
               {
						SHELLEXECUTEINFO helpShellInfo;

                  CloseHandle(textfile);

                  memset(&helpShellInfo,0,sizeof(SHELLEXECUTEINFO));
						helpShellInfo.cbSize = sizeof(SHELLEXECUTEINFO);
                  helpShellInfo.lpFile = szHelpFile;
                  helpShellInfo.nShow = SW_SHOWDEFAULT;
                  helpShellInfo.fMask = SEE_MASK_NOCLOSEPROCESS;

						if(!ShellExecuteEx(&helpShellInfo))
		               MessageBox(mainWnd,szNoHelp,szAppName,MB_ICONINFORMATION|MB_OK);
               }
               else
               {
	               MessageBox(mainWnd,szNoHelp,szAppName,MB_ICONINFORMATION|MB_OK);
					}
               break;
            default:
               break;
         }
         result = TRUE;
         break;
      case WM_CLOSE:
         free(cTable);
         EndDialog(mainWnd,TRUE);
         result = FALSE;
         break;
      default :
         result = FALSE;
   }
   return result;
}

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR     lpCmdLine, int       nCmdShow)
{
   LoadString(hInst, IDS_APPNAME , szAppName   , sizeof(szAppName  ));
   LoadString(hInst, IDS_TITLE   , szTitle     , sizeof(szTitle    ));
   LoadString(hInst, IDS_NOHELP  , szNoHelp    , sizeof(szNoHelp   ));
   LoadString(hInst, IDS_HELPFILE, szHelpFile  , sizeof(szHelpFile ));
   LoadString(hInst, IDS_DRAG1   , szFirstDrag , sizeof(szFirstDrag));

   hInst = hInstance;
   return DialogBox(hInstance, MAKEINTRESOURCE(IDD_APP32), NULL, AppDlgProc);
}

